# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`hyperglass::agent`](#hyperglassagent): installs the hyperglass linux agent
* [`hyperglass::server`](#hyperglassserver): installs the hyperglass looking glass

#### Private Classes

* `hyperglass::agent::config`: configures the hyperglass looking agent
* `hyperglass::agent::install`: installs the hyperglass agent on linux nodes
* `hyperglass::agent::service`: manages the hyperglass agent service + unit file
* `hyperglass::gcc`: module to workaround the broken puppetlabs/gcc class. Installs just gcc
* `hyperglass::hyperglassdir`: private class to create the main dir for hyperglass server and agent
* `hyperglass::python`: private class used by server/agent to install python3
* `hyperglass::server::config`: writes the hyperglass config files
* `hyperglass::server::dependencies`: private class that installs all the services hyperglass depends on
* `hyperglass::server::install`: installs the hyperglass server
* `hyperglass::server::service`: manages the hyperglass service + unit file

## Classes

### `hyperglass::agent`

installs the hyperglass linux agent

* **See also**
  * https://github.com/checktheroads/hyperglass-agent

#### Parameters

The following parameters are available in the `hyperglass::agent` class.

##### `manage_python`

Data type: `Boolean`

installs python3

Default value: ``true``

##### `manage_gcc`

Data type: `Boolean`

installs gcc

Default value: ``true``

##### `data`

Data type: `Hash`

generic hyperglass configuration hash.

Default value: `{
    'debug'          => true,
    'listen_address' => '127.0.0.1',
    'mode'           => 'bird',
    'secret'         => fqdn_rand_string(20),
    'ssl'            => {
      'enable' => false,
    },
  }`

### `hyperglass::server`

installs the hyperglass looking glass

* **See also**
  * https://hyperglass.io/

#### Parameters

The following parameters are available in the `hyperglass::server` class.

##### `manage_depended_services`

Data type: `Boolean`

if true, installs all other services that hyperglass requires, like redis, yarn, nginx, python

Default value: ``true``

##### `manage_python`

Data type: `Boolean`

installs python3

Default value: ``true``

##### `manage_gcc`

Data type: `Boolean`

installs gcc

Default value: ``true``

##### `devices`

Data type: `Hash`

hash containing all the devices hyperglass can connect to. Defaults to demo data so the service starts properly.

Default value: `{
    'routers' => [
      {
        'name' => 'atl_router01',
        'address' => '10.0.0.2',
        'network' => {
          'name' => 'secondary',
          'display_name' => 'That Other Network',
        },
        'credential' => {
          'username' => 'user2',
          'password' => ' secret2',
        },
        'display_name' => 'Atlanta, GA',
        'port' => 22,
        'nos' => 'juniper',
        'vrfs' => [
          {
            'name' => 'default',
            'display_name' => 'Global',
            'ipv4' => {
              'source_address' => '192.0.2.2',
            },
          },
        ],
      },
    ],
  }`

##### `commands`

Data type: `Hash`

specific commands that can be used by the devices

Default value: `{}`

##### `data`

Data type: `Hash`

generic hyperglass configuration hash.

Default value: `{}`

